//class for count down timer.
//version : 1.0.0
//created : 2018/02/16
//by hideki suehiro
//
class CountDownTimer {

	//constructor
	constructor(){
		//init
		this.status = 0;
		this.count_org = 0;
		this.count = this.count_org;
		this.doStart();
	}

	//for test
	doTest() {
		alert("hello,CountDownTimer");
	}

	//start main loop.
	doStart() {
		console.log("doStart()");
		var me = this;
		//main loop (1000ms)
		var id = setInterval(function(){
			console.log("count:" + me.count + ":" + me.status);
			if(me.status == 1) {
				me.countdown(me);
				if(me.count < 0){
					me.stoptimer();
				}
			}
		}, 1000);
	}

	//count down
	countdown(me) {
		me.updateTime();
		me.count--;
		console.log("countdown():" + me.count);
	}

	//player
	stoptimer() {
		this.count = this.count_org;
		this.doSuspend();
	}

	//player
	setTime(sec) {
		console.log("setTime()");
		this.doSuspend();
		this.count_org = sec;
		this.count = sec;
		this.updateTime();
	}

	//update UI
	updateTime() {
	}

	//controller
	doSuspend() {
		this.status = 0;
	}

	//controller
	doPlay() {
		this.status = 1;
	}
}

